#ifndef __BLACKBOX_HEADER__
#define __BLACKBOX_HEADER__

#include "alchemist.h"

#ifndef ALCHEMIST_BLACKBOX_MOD_PATH
#define ALCHEMIST_BLACKBOX_MOD_PATH "/usr/lib/alchemist/blackbox"
#endif

typedef struct AdmBlackBoxMethods {
	void	     (*free)		    (void	  *data);

	AdmContext * (*read)		    (void	  *data,
					     AdmError **error);

	unsigned int (*listSerial)	    (void	  *data,
					     unsigned int *array,
					     unsigned int  array_len,
					     unsigned int  top_serial,
					     AdmError **error);

	AdmContext * (*readSerial)	    (void	  *data,
					     unsigned int  serial,
					     AdmError **error);

	int	     (*write)		    (void	  *data,
					     AdmContext   *context,
					     AdmError **error);
} AdmBlackBoxMethods;

/* every module exports one of these named 'bb_mod_vector' */
struct AdmBlackBoxModuleVector {
	int	abi_major_ver;
	int	abi_minor_ver;
	int   (*getBox) (AdmBlackBoxMethods    **mod,
			 void		       **data,
			 AdmList		*box_list,
			 AdmError **error);
};

#endif/*__BLACKBOX_HEADER__*/
